#ifndef CWARE_LIBERROR_PUBLIC_H
#define CWARE_LIBERROR_PUBLIC_H

#if defined(CWARE_SAFETY_CHECKS)
#define LIBERROR_ASSERT(expression, type, message, function)                                  \
    do {                                                                                      \
        if((expression) != 0) {                                                               \
            break;                                                                            \
        }                                                                                     \
                                                                                              \
        fprintf(stderr, "%s\t%s\t%s\t%s\t%i\n", type, function, message, __FILE__, __LINE__); \
        abort();                                                                              \
    } while(0)

#define LIBERROR_TEST(expression, message) \
    LIBERROR_ASSERT(expression, "ASSERTION", message, "main")

#else

#define LIBERROR_ASSERT(expression, message)
#define LIBERROR_TEST(expression, type, message, function)
#endif

#endif
